; -----------------------
;| My first NES rom using|
;| five of the palettes! |
;|-----------------------|
;|a bone to chew         |
;|abonetochew@hotmail.com|
; -----------------------

Vcontrol1 =0
Vx1 =1
Vx2 =2
Vx3 =3
Vx4 =4
Vy1 =5
Vy2 =6
Vy3 =7
Vy4 =8
Vy5 =9

.org 0C000h
begin	ldx #0FFh	;initialize stack
	txs
vblank	lda 2002h	;wait for vblank
	bpl vblank
	lda #00000000b	;control PPU 1
	sta 2000h
	lda #00011110b	;control PPU 2
	sta 2001h
	lda #0		;no scrolling
	sta 2005h
	sta 2005h

	lda #3Fh	;set bg palettes
	sta 2006h
	lda #0
	sta 2006h
	lda #0Ch	;bg pal 0 color 0 (should be
	sta 2007h	;same in different pals)
	lda #0Fh	;bg pal 0 color 1
	sta 2007h
	lda #00h	;bg pal 0 color 2
	sta 2007h
	lda #30h	;bg pal 0 color 3
	sta 2007h
	lda #0Ch	;bg pal 1 color 0
	sta 2007h
	lda #0Ch	;bg pal 1 color 1
	sta 2007h
	lda #0Ch	;bg pal 1 color 2
	sta 2007h
	lda #0Ch	;bg pal 1 color 3
	sta 2007h
	lda #0Ch	;bg pal 2 color 0
	sta 2007h
	lda #0Ch	;bg pal 2 color 1
	sta 2007h
	lda #0Ch	;bg pal 2 color 2
	sta 2007h
	lda #0Ch	;bg pal 2 color 3
	sta 2007h
	lda #0Ch	;bg pal 3 color 0
	sta 2007h
	lda #0Ch	;bg pal 3 color 1
	sta 2007h
	lda #0Ch	;bg pal 3 color 2
	sta 2007h
	lda #0Ch	;bg pal 3 color 3
	sta 2007h



	lda #3Fh	;set sprite palettes
	sta 2006h
	lda #10h
	sta 2006h
	lda #0Ch	;sprite pal 0 color 0 (transparent,
	sta 2007h	;keep same as bg color 0)
	lda #02h	;sprite pal 0 color 1
	sta 2007h
	lda #12h	;sprite pal 0 color 2
	sta 2007h
	lda #22h	;sprite pal 0 color 3
	sta 2007h
	lda #0Ch	;sprite pal 1 color 0 (transparent)
	sta 2007h
	lda #1Ch	;sprite pal 1 color 1
	sta 2007h
	lda #2Ch	;sprite pal 1 color 2
	sta 2007h
	lda #3Ch	;sprite pal 1 color 3
	sta 2007h
	lda #0Ch	;sprite pal 2 color 0 (transparent)
	sta 2007h
	lda #06h	;sprite pal 2 color 1
	sta 2007h
	lda #17h	;sprite pal 2 color 2
	sta 2007h
	lda #27h	;sprite pal 2 color 3
	sta 2007h
	lda #0Ch	;sprite pal 3 color 0 (transparent)
	sta 2007h
	lda #16h	;sprite pal 3 color 1
	sta 2007h
	lda #0Ch	;sprite pal 3 color 2
	sta 2007h
	lda #0Ch	;sprite pal 3 color 3
	sta 2007h
;---------------- background (name tables) **
	lda #20h	;this fills the name table with tile numbers
	sta 2006h	;it copies the numbers at the end of the file
	sta 2006h
	ldx #0
loop1	lda 0E000h,X
	sta 2007h
	inx
	cpx #0E0h
	bne loop1
	ldx #0
loop2	lda 0E0E0h,X
	sta 2007h
	inx
	cpx #0E0h
	bne loop2
	ldx #0
loop3	lda 0E1C0h,X
	sta 2007h
	inx
	cpx #0E0h
	bne loop3
	ldx #0
loop4	lda 0E2A0h,X
	sta 2007h
	inx
	cpx #0E0h
	bne loop4
;---------------- set up vars
	lda #08h
	sta Vx1
	lda #10h
	sta Vx2
	lda #18h
	sta Vx3
	lda #20h
	sta Vx4
	lda #0Fh
	sta Vy1
	lda #17h
	sta Vy2
	lda #1Fh
	sta Vy3
	lda #27h
	sta Vy4
	lda #2Fh
	sta Vy5
;---------------- main loop
mainloop
	jsr readcontrol1
	jsr delay	;we need delay to see it
	jsr delay
	jsr delay
	jsr delay
	lda Vcontrol1	;check for no buttons pressed
	beq nobutton
	and #00000001b	;check for not right
	beq noright
;	inc Vx1		;if it is right
;	jmp nobutton
noright	lda Vcontrol1
	and #00000010b	;check for not left
	beq noleft
;	dec Vx1		;if it is left
;	jmp nobutton
noleft	lda Vcontrol1
	and #00000100b	;check for not down
	beq nodown
;	inc Vy1		;if it is down
;	jmp nobutton
nodown	lda Vcontrol1
	and #00001000b	;check for not up
	beq nobutton
;	dec Vy1		;if it is up
;	jmp nobutton
nobutton
	jsr sprites
	jmp mainloop
; -------------
;| subroutines |
; -------------
;---------------- read controller 1
readcontrol1 lda #1
	sta 4016h
	lda #0
	sta 4016h
	sta Vcontrol1
	ldx #8
control1 lda 4016h
	and #1
	ora Vcontrol1
	asl A
	sta Vcontrol1
	dex
	bne control1
	bcc noabutton
	lsr A
	ora #10000000b
	bne endreading
noabutton lsr A
endreading sta Vcontrol1
	rts
;---------------- delay
delay	pha		;save A & X in stack
	txa
	pha
	ldx #0FFh
delayloop
	lda 0D000h,X	;loop doing a slow operation
	dex
	bne delayloop
	pla		;restore A & X from stack
	tax
	pla
	rts
;---------------- sprites
sprites	lda 2002h	;wait for vblank
	bpl sprites
	lda #0		;sprite
	sta 2003h
;-------
	lda Vy1		;set y to Vy1 on sprite 0
	sta 2004h
	lda #05h	;use tile 05		[X.xX]
	sta 2004h	;			[xxxX]
	lda #0		;sprite pal 0		[xxxx]
	sta 2004h	;			[xxxx]
	lda Vx2		;set x to Vx2		[xxxx]
	sta 2004h
;-------
	lda Vy1		;set y to Vy1 on sprite 1
	sta 2004h
	lda #06h	;use tile 06		[Xx.X]
	sta 2004h	;			[xxxX]
	lda #0		;sprite pal 0		[xxxx]
	sta 2004h	;			[xxxx]
	lda Vx3		;set x to Vx3		[xxxx]
	sta 2004h
;-------
	lda Vy2		;set y to Vy2 on sprite 2
	sta 2004h
	lda #14h	;use tile 14		[XxxX]
	sta 2004h	;			[.xxX]
	lda #0		;sprite pal 0		[xxxx]
	sta 2004h	;			[xxxx]
	lda Vx1		;set x to Vx1		[xxxx]
	sta 2004h
;-------
	lda Vy2		;set y to Vy2 on sprite 3
	sta 2004h
	lda #15h	;use tile 15		[XxxX]
	sta 2004h	;			[x.xX]
	lda #0		;sprite pal 0		[xxxx]
	sta 2004h	;			[xxxx]
	lda Vx2		;set x to Vx2		[xxxx]
	sta 2004h
;-------
	lda Vy2		;set y to Vy2 on sprite 4
	sta 2004h
	lda #16h	;use tile 16		[XxxX]
	sta 2004h	;			[xx.X]
	lda #0		;sprite pal 0		[xxxx]
	sta 2004h	;			[xxxx]
	lda Vx3		;set x to Vx3		[xxxx]
	sta 2004h
;-------
	lda Vy3		;set y to Vy3 on sprite 5
	sta 2004h
	lda #24h	;use tile 24		[XxxX]
	sta 2004h	;			[xxxX]
	lda #0		;sprite pal 0		[.xxx]
	sta 2004h	;			[xxxx]
	lda Vx1		;set x to Vx1		[xxxx]
	sta 2004h
;-------
	lda Vy3		;set y to Vy3 on sprite 6
	sta 2004h
	lda #25h	;use tile 25		[XxxX]
	sta 2004h	;			[xxxX]
	lda #0		;sprite pal 0		[x.xx]
	sta 2004h	;			[xxxx]
	lda Vx2		;set x to Vx2		[xxxx]
	sta 2004h
;-------
	lda Vy3		;set y to Vy3 on sprite 7
	sta 2004h
	lda #26h	;use tile 26		[XxxX]
	sta 2004h	;			[xxxX]
	lda #0		;sprite pal 0		[xx.x]
	sta 2004h	;			[xxxx]
	lda Vx3		;set x to Vx3		[xxxx]
	sta 2004h
;-------
	lda Vy3		;set y to Vy3 on sprite 8
	sta 2004h
	lda #27h	;use tile 27		[XxxX]
	sta 2004h	;			[xxxX]
	lda #0		;sprite pal 0		[xxx.]
	sta 2004h	;			[xxxx]
	lda Vx4		;set x to Vx4		[xxxx]
	sta 2004h
;-------
	lda Vy4		;set y to Vy4 on sprite 9
	sta 2004h
	lda #34h	;use tile 34		[XxxX]
	sta 2004h	;			[xxxX]
	lda #0		;sprite pal 0		[xxxx]
	sta 2004h	;			[.xxx]
	lda Vx1		;set x to Vx1		[xxxx]
	sta 2004h
;-------
	lda Vy4		;set y to Vy4 on sprite 10
	sta 2004h
	lda #35h	;use tile 35		[XxxX]
	sta 2004h	;			[xxxX]
	lda #0		;sprite pal 0		[xxxx]
	sta 2004h	;			[x.xx]
	lda Vx2		;set x to Vx2		[xxxx]
	sta 2004h
;-------
	lda Vy4		;set y to Vy4 on sprite 11
	sta 2004h
	lda #36h	;use tile 36		[XxxX]
	sta 2004h	;			[xxxX]
	lda #0		;sprite pal 0		[xxxx]
	sta 2004h	;			[xx.x]
	lda Vx3		;set x to Vx3		[xxxx]
	sta 2004h
;-------
	lda Vy4		;set y to Vy4 on sprite 12
	sta 2004h
	lda #37h	;use tile 37		[XxxX]
	sta 2004h	;			[xxxX]
	lda #0		;sprite pal 0		[xxxx]
	sta 2004h	;			[xxx.]
	lda Vx4		;set x to Vx4		[xxxx]
	sta 2004h
;-------
	lda Vy5		;set y to Vy5 on sprite 13
	sta 2004h
	lda #44h	;use tile 44		[XxxX]
	sta 2004h	;			[xxxX]
	lda #0		;sprite pal 0		[xxxx]
	sta 2004h	;			[xxxx]
	lda Vx1		;set x to Vx1		[.xxx]
	sta 2004h
;-------
	lda Vy5		;set y to Vy5 on sprite 14
	sta 2004h
	lda #45h	;use tile 45		[XxxX]
	sta 2004h	;			[xxxX]
	lda #0		;sprite pal 0		[xxxx]
	sta 2004h	;			[xxxx]
	lda Vx2		;set x to Vx2		[x.xx]
	sta 2004h
;-------
	lda Vy5		;set y to Vy5 on sprite 15
	sta 2004h
	lda #46h	;use tile 46		[XxxX]
	sta 2004h	;			[xxxX]
	lda #0		;sprite pal 0		[xxxx]
	sta 2004h	;			[xxxx]
	lda Vx3		;set x to Vx3		[xx.x]
	sta 2004h
;-------
	lda Vy5		;set y to Vy5 on sprite 16
	sta 2004h
	lda #47h	;use tile 47		[XxxX]
	sta 2004h	;			[xxxX]
	lda #0		;sprite pal 0		[xxxx]
	sta 2004h	;			[xxxx]
	lda Vx4		;set x to Vx4		[xxx.]
	sta 2004h
;---------------- pal 1
	lda Vy1		;set y to Vy1 on sprite 17
	sta 2004h
	lda #0Ah	;use tile 0A		[XX.X]
	sta 2004h	;			[XxxX]
	lda #1		;sprite pal 1		[XxxX]
	sta 2004h	;			[XXxX]
	lda Vx3		;set x to Vx3		[XXXX]
	sta 2004h
;-------
	lda Vy2		;set y to Vy2 on sprite 18
	sta 2004h
	lda #19h	;use tile 19		[XXxX]
	sta 2004h	;			[X.xX]
	lda #1		;sprite pal 1		[XxxX]
	sta 2004h	;			[XXxX]
	lda Vx2		;set x to Vx2		[XXXX]
	sta 2004h
;-------
	lda Vy2		;set y to Vy2 on sprite 19
	sta 2004h
	lda #1Ah	;use tile 1A		[XXxX]
	sta 2004h	;			[Xx.X]
	lda #1		;sprite pal 1		[XxxX]
	sta 2004h	;			[XXxX]
	lda Vx3		;set x to Vx3		[XXXX]
	sta 2004h
;-------
	lda Vy3		;set y to Vy3 on sprite 20
	sta 2004h
	lda #29h	;use tile 29		[XXxX]
	sta 2004h	;			[XxxX]
	lda #1		;sprite pal 1		[X.xX]
	sta 2004h	;			[XXxX]
	lda Vx2		;set x to Vx2		[XXXX]
	sta 2004h
;-------
	lda Vy3		;set y to Vy3 on sprite 21
	sta 2004h
	lda #2Ah	;use tile 2A		[XXxX]
	sta 2004h	;			[XxxX]
	lda #1		;sprite pal 1		[Xx.X]
	sta 2004h	;			[XXxX]
	lda Vx3		;set x to Vx3		[XXXX]
	sta 2004h
;-------
	lda Vy4		;set y to Vy4 on sprite 22
	sta 2004h
	lda #3Ah	;use tile 3A		[XXxX]
	sta 2004h	;			[XxxX]
	lda #1		;sprite pal 1		[XxxX]
	sta 2004h	;			[XX.X]
	lda Vx3		;set x to Vx3		[XXXX]
	sta 2004h
;---------------- pal 2
	lda Vy1		;set y to Vy1 on sprite 23
	sta 2004h
	lda #0Eh	;use tile 0E		[XX.X]
	sta 2004h	;			[XXxX]
	lda #2		;sprite pal 2		[XXXX]
	sta 2004h	;			[XXXX]
	lda Vx3		;set x to Vx3		[XXXX]
	sta 2004h
;-------
	lda Vy2		;set y to Vy2 on sprite 24
	sta 2004h
	lda #1Eh	;use tile 1E		[XXxX]
	sta 2004h	;			[XX.X]
	lda #2		;sprite pal 2		[XXXX]
	sta 2004h	;			[XXXX]
	lda Vx3		;set x to Vx3		[XXXX]
	sta 2004h
;---------------- pal 3
	lda Vy1		;set y to Vy1 on sprite 25
	sta 2004h
	lda #52h	;use tile 52		[XX.X]
	sta 2004h	;			[XxXX]
	lda #3		;sprite pal 3		[XXXX]
	sta 2004h	;			[XXXX]
	lda Vx3		;set x to Vx3		[XXXX]
	sta 2004h
;-------
	lda Vy2		;set y to Vy2 on sprite 26
	sta 2004h
	lda #61h	;use tile 61		[XXxX]
	sta 2004h	;			[X.XX]
	lda #3		;sprite pal 3		[XXXX]
	sta 2004h	;			[XXXX]
	lda Vx2		;set x to Vx2		[XXXX]
	sta 2004h
	rts
;-------------------------------- background
.org 0E000h
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,00h,01h,02h,03h,0,0,0,0,0,0,0,0,0,0,0
.db 	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,10h,11h,12h,13h,0,0,0,0,0,0,0,0,0,0,0
.db 	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,20h,21h,22h,23h,0,0,0,0,0,0,0,0,0,0,0
.db 	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,30h,31h,32h,33h,0,0,0,0,0,0,0,0,0,0,0
.db 	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,40h,41h,42h,43h,0,0,0,0,0,0,0,0,0,0,0
.db 	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.db 	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
;--------------------------------
.org 0FF00h	;interruption NMI (useless, but just in case)
	rti
.org 0FFFAh	;interruption vectors
.db	0,0FFh,0,0C0h,0,0C0h
.end
